#region Using

using System;
using System.Text;
using System.Text.RegularExpressions;
using System.Net;
using BlogEngine.Core;
using BlogEngine.Core.Web.Controls;

#endregion

[Extension("Replaces [SIMBEGAL:*pathname*] with the Simbegal user control.", "1.0", "Createdbyx.com")]
public class SimbegalEx
{
    public SimbegalEx()
    {
        Post.Serving += new EventHandler<ServingEventArgs>(Serving);
        Page.Serving += new EventHandler<ServingEventArgs>(Serving);
    }

    private void Serving(object sender, ServingEventArgs e)
    {
        if (!e.Body.Contains("[SIMBEGAL:"))
            return;

        int startPos = e.Body.IndexOf("[SIMBEGAL:");
        int endPos = e.Body.IndexOf("]", startPos + 10);
        if (startPos != -1 && endPos != -1 && endPos >= startPos)
        {
            string path = e.Body.Substring(startPos + 10, endPos - (startPos + 10));

            string uc = "[usercontrol: /user controls/Simbegal.ascx " + (path == string.Empty ? string.Empty : "PathRoot=" + path) + "]";
            e.Body = e.Body.Remove(startPos, (endPos + 1) - startPos);
            e.Body = e.Body.Insert(startPos, uc);
        }
    }
}
